----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    11:26:30 01/23/2013 
-- Design Name: 
-- Module Name:    evt_bldr - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;
use work.amc13_pack.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;
Library UNIMACRO;
use UNIMACRO.vcomponents.all;

entity evt_bldr12 is
    Port ( clk : in  STD_LOGIC;
					 reset : in STD_LOGIC;
					 fifo_rst : in STD_LOGIC;
					 fifo_en : in STD_LOGIC;
					 OneSFP : in STD_LOGIC;
           Source_ID : in  STD_LOGIC_VECTOR (7 downto 0);
           AMC_wc : in  STD_LOGIC_VECTOR (13 downto 0); -- bit 9-0 64bit word count, bit 13-10 is AMC channel number
					 AMC_wc_we : in STD_LOGIC;
					 AMC_wc_end : in STD_LOGIC;
					 wc_fifo_full : out STD_LOGIC;
           AMC_header : in  STD_LOGIC_VECTOR (64 downto 0);
           AMC_header_mask : in  STD_LOGIC_VECTOR (1 downto 0);
					 AMC_header_we : in STD_LOGIC;
					 AMC_DATA : in array12X64;
					 AMC_DATA_re : out STD_LOGIC_VECTOR (11 downto 0);
           evt_data : out  STD_LOGIC_VECTOR (65 downto 0);
					 evt_data_we : out STD_LOGIC;
					 evt_buf_full : in STD_LOGIC;
					 evt_data_re : in STD_LOGIC;
					 evt_data_rdy : out STD_LOGIC;
					 EventBuilt : out STD_LOGIC);
end evt_bldr12;

architecture Behavioral of evt_bldr12 is
COMPONENT cmsCRC64
	PORT(
		clk : IN std_logic;
		reset : IN std_logic;
		crc_init : IN std_logic;
		trailer : IN std_logic;
		crc_d : IN std_logic_vector(63 downto 0);
		crc_ce : IN std_logic;          
		crc : OUT std_logic_vector(15 downto 0);
		crc_err : OUT std_logic;
		dout : OUT std_logic_vector(63 downto 0);
		dout_vld : OUT std_logic
		);
END COMPONENT;
COMPONENT sr64
	PORT(
		a : IN std_logic_vector(5 downto 0);
		d : IN std_logic_vector(0 to 0);
		clk : IN std_logic;
		ce : IN std_logic;          
		q : OUT std_logic_vector(0 to 0)
		);
END COMPONENT;
signal fifo_we : std_logic := '0';
signal fifo_re : std_logic := '0';
signal fifo_empty : std_logic_vector(7 downto 0) := (others => '0');
signal fifo_full : std_logic_vector(7 downto 0) := (others => '0');
signal FIFO_di : std_logic_vector(71 downto 0) := (others => '0');
signal FIFO_do : std_logic_vector(71 downto 0) := (others => '0');
signal channel : std_logic_vector(3 downto 0) := (others => '0');
signal evt_data_we_i : std_logic := '0';
signal en_output : std_logic := '0';
signal evt_data_vld : std_logic := '0';
signal evt_buf_do_vld : std_logic := '0';
signal evt_buf_re : std_logic := '0';
signal evt_cnt : std_logic_vector(3 downto 0) := (others => '0');
signal evt_buf_regce : std_logic := '0';
signal evt_buf_we : std_logic_vector(0 downto 0) := (others => '0');
signal buf_full : std_logic := '0';
signal AMC_DATA_re_i : std_logic := '0';
signal AMC_header_avl : std_logic := '0';
signal AMC_header_re : std_logic := '0';
signal header_ra_selected : std_logic := '0';
signal AMC_header_vld : std_logic := '0';
--signal ec_header_wa : std_logic := '0';
signal evt_buf_avl : std_logic := '0';
signal evt_buf_wc : std_logic_vector(11 downto 0) := (others => '0');
signal evt_buf_wa : std_logic_vector(11 downto 0) := (others => '0');
signal FIFO_data_wa : std_logic_vector(11 downto 0) := (others => '0');
signal FIFO_data_wa_q : std_logic_vector(11 downto 0) := (others => '0');
signal header_wa : std_logic_vector(6 downto 0) := (others => '0');
signal header_ra : std_logic_vector(6 downto 0) := (others => '0');
signal evt_buf_din : std_logic_vector(71 downto 0) := (others => '0');
signal evt_buf_doa : std_logic_vector(71 downto 0) := (others => '0');
signal evt_buf_ra : std_logic_vector(11 downto 0) := (others => '0');
signal evt_buf_dout : std_logic_vector(71 downto 0) := (others => '0');
signal wc_fifo_a : std_logic_vector(5 downto 0) := (others => '0');
signal wc_fifo_di : std_logic_vector(14 downto 0) := (others => '0');
signal wc_fifo_do : std_logic_vector(14 downto 0) := (others => '0');
signal wc_fifo_we : std_logic := '0';
signal wc_fifo_empty : std_logic := '0';
signal wc_fifo_di_vld : std_logic := '0';
signal NoAMCenabled : std_logic := '1';
signal idle : std_logic := '1';
signal read_AMC : std_logic := '0';
signal last_channel : std_logic := '0';
signal wc : std_logic_vector(9 downto 0) := (others => '0');
signal crc_init : std_logic := '0';
signal crc_ce : std_logic := '0';
signal rd_last_header : std_logic := '0';
signal rd_last_header_q : std_logic := '0';
signal crc_data : std_logic_vector(63 downto 0) := (others => '0');
signal trailer_we : std_logic := '0';
--signal trailer_we_q : std_logic := '0';
signal trailer : std_logic_vector(63 downto 0) := (others => '0');
signal trailer_dl : std_logic_vector(2 downto 0) := (others => '0');
type array8X12 is array (0 to 7) of std_logic_vector(11 downto 0);
signal rdcount : array8X12 := (others => (others => '0'));
signal wrcount : array8X12 := (others => (others => '0'));
begin
evt_data <= evt_buf_dout(65 downto 0);
evt_data_we <= evt_data_we_i;
EventBuilt <= trailer_we;
g_wc_fifo: for i in 0 to 14 generate
	i_wc_fifo: sr64 port map(a => wc_fifo_a, d => wc_fifo_di(i downto i), clk => clk, ce => wc_fifo_we, q => wc_fifo_do(i downto i));
end generate;
wc_fifo_di(14) <= AMC_wc_end;
wc_fifo_we <= wc_fifo_di_vld and (AMC_wc_we or AMC_wc_end);
process(clk)
begin
	if(clk'event and clk = '1')then
		if(AMC_wc_we = '1')then
			wc_fifo_di(13 downto 0) <= AMC_wc;
		end if;
		if(fifo_en = '0')then
			NoAMCenabled <= '0';
		elsif(AMC_wc_end = '1')then
			NoAMCenabled <= not wc_fifo_di_vld;
		end if;
		if(fifo_en = '0' or AMC_wc_end = '1')then
			wc_fifo_di_vld <= '0';
		elsif(AMC_wc_we = '1')then
			wc_fifo_di_vld <= '1';
		end if;
		if(AMC_header_we = '1')then
			if(AMC_header_mask(0) = '1')then
				evt_buf_din(31 downto 0) <= AMC_header(31 downto 0);
			else
				evt_buf_din(31 downto 0) <= (others => '0');
			end if;
			if(AMC_header_mask(1) = '1')then
				evt_buf_din(63 downto 32) <= AMC_header(63 downto 32);
			else
				evt_buf_din(63 downto 32) <= (others => '0');
			end if;
			evt_buf_din(71 downto 65) <= (others => '0');
			evt_buf_din(64) <= AMC_header(64);
		else
			evt_buf_din <= FIFO_do;
		end if;
		if(AMC_header_we = '1')then
			evt_buf_wa <= "11111" & header_wa;
		elsif(AMC_header_re = '1')then
			evt_buf_wa <= "11111" & header_ra;
		else
			evt_buf_wa <= FIFO_data_wa;
		end if;
		if(fifo_en = '0')then
			FIFO_data_wa <= (others => '0');
		elsif(FIFO_re = '1')then
			if(FIFO_data_wa = x"f7f")then
				FIFO_data_wa <= (others => '0');
			else
				FIFO_data_wa <= FIFO_data_wa + 1;
			end if;
		end if;
		if(fifo_en = '0')then
			FIFO_data_wa_q <= (others => '0');
		else
			FIFO_data_wa_q <= FIFO_data_wa;
		end if;
		evt_buf_we(0) <= FIFO_re or AMC_header_we;
		if(evt_buf_wc(11 downto 8) = x"f" and evt_buf_wc(6 downto 3) = x"f")then
			evt_buf_avl <= '0';
		else
			evt_buf_avl <= '1';
		end if;
--		ec_header_wa <= not reset and AMC_header_we;
		if(fifo_en = '0')then
			header_wa <= (others => '0');
		elsif(AMC_header_we = '1')then
			if(header_wa(2 downto 0) = "101")then
				header_wa(2 downto 0) <= "000";
				header_wa(6 downto 3) <= header_wa(6 downto 3) + 1;
			else
				header_wa(2 downto 0) <= header_wa(2 downto 0) + 1;
			end if;
		end if;
		if(fifo_en = '0' or header_wa = header_ra)then
			AMC_header_avl <= '0';
		else
			AMC_header_avl <= '1';
		end if;
		header_ra_selected <= fifo_en and AMC_header_re and not AMC_header_we;
		AMC_header_vld <= fifo_en and header_ra_selected;
		if(AMC_header_vld = '1')then
			FIFO_di(65) <= not evt_buf_doa(64);
		end if;
		crc_ce <= fifo_en and (AMC_header_vld or AMC_DATA_re_i or trailer_we);
		if(AMC_DATA_re_i = '1')then
			crc_data <= AMC_DATA(CONV_INTEGER(channel));
		elsif(trailer_we = '1')then
			crc_data <= trailer;
		else
			crc_data <= evt_buf_doa(63 downto 0);
		end if;
--		trailer_we_q <= trailer_we;
		crc_init <= not fifo_en or trailer_dl(0);
		if(fifo_en = '0')then
			wc_fifo_full <= '0';
		elsif(OneSFP = '1')then
			if(wc_fifo_a(5 downto 3) = "110")then
				wc_fifo_full <= '1';
			elsif(wc_fifo_a(5 downto 3) = "101")then
				wc_fifo_full <= '0';
			end if;
		else
			if(wc_fifo_a(5 downto 2) = x"e")then
				wc_fifo_full <= '1';
			elsif(wc_fifo_a(5 downto 2) = x"d")then
				wc_fifo_full <= '0';
			end if;
		end if;
		wc_fifo_empty <= not fifo_en or and_reduce(wc_fifo_a);
		if(fifo_en = '0')then
			wc_fifo_a <= (others => '1');
		elsif(wc_fifo_we = '1' and (read_AMC = '0' or fifo_full(0) = '1'))then
			wc_fifo_a <= wc_fifo_a + 1;
		elsif(wc_fifo_we = '0' and and_reduce(wc_fifo_a) = '0' and read_AMC = '1' and fifo_full(0) = '0')then
			wc_fifo_a <= wc_fifo_a - 1;
		end if;
	end if;
end process;
i_EventCRC: cmsCRC64 PORT MAP(
		clk => clk,
		reset => reset,
		crc_init => crc_init,
		trailer => trailer_dl(0),
		crc_d => crc_data,
		crc_ce => crc_ce,
		crc => open,
		crc_err => open,
		dout => FIFO_di(63 downto 0),
		dout_vld => FIFO_we
	);
g_evt_FIFO: for i in 0 to 7 generate
   i_evt_FIFO : FIFO_DUALCLOCK_MACRO
   generic map (
      DEVICE => "7SERIES",            -- Target Device: "VIRTEX5", "VIRTEX6", "7SERIES" 
      ALMOST_FULL_OFFSET => X"0210",  -- Sets almost full threshold
      ALMOST_EMPTY_OFFSET => X"0080", -- Sets the almost empty threshold
      DATA_WIDTH => 9,   -- Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      FIFO_SIZE => "36Kb",            -- Target BRAM, "18Kb" or "36Kb" 
      FIRST_WORD_FALL_THROUGH => TRUE) -- Sets the FIFO FWFT to TRUE or FALSE
   port map (
      ALMOSTEMPTY => open,   -- 1-bit output almost empty
      ALMOSTFULL => fifo_full(i),     -- 1-bit output almost full
      DO => FIFO_do(i*9+8 downto i*9),                     -- Output data, width defined by DATA_WIDTH parameter
      EMPTY => FIFO_empty(i),               -- 1-bit output empty
      FULL => open,                 -- 1-bit output full
      RDCOUNT => rdcount(i),           -- Output read count, width determined by FIFO depth
      RDERR => open,               -- 1-bit output read error
      WRCOUNT => wrcount(i),           -- Output write count, width determined by FIFO depth
      WRERR => open,               -- 1-bit output write error
      DI => FIFO_di(i*9+8 downto i*9),                     -- Input data, width defined by DATA_WIDTH parameter
      RDCLK => clk,               -- 1-bit input read clock
      RDEN => FIFO_re,                 -- 1-bit input read enable
      RST => fifo_rst,                   -- 1-bit input reset
      WRCLK => clk,               -- 1-bit input write clock
      WREN => FIFO_we                  -- 1-bit input write enable
   );
end generate;
FIFO_di(64) <= trailer_dl(2);
FIFO_re <= fifo_en and evt_buf_avl and not FIFO_empty(0) and not AMC_header_we and not AMC_header_re;
process(clk)
begin
	if(clk'event and clk = '1')then
		if(fifo_en = '0')then
			en_output <= '0';
		elsif(evt_data_re = '1')then
			en_output <= '1';
		elsif(evt_data_we_i = '1' and evt_buf_dout(64) = '1')then
			en_output <= '0';
		end if;
		if(fifo_en = '0' or (evt_data_we_i = '1' and evt_buf_dout(64) = '1') or evt_data_vld = '0' or (evt_data_we_i = '1' and evt_buf_do_vld = '0'))then
			evt_data_we_i <= '0';
		else
			evt_data_we_i <= en_output and not evt_buf_full;
		end if;
		if(fifo_en = '0')then
			evt_data_vld <= '0';
		elsif(evt_buf_do_vld = '1')then
			evt_data_vld <= '1';
		elsif(evt_data_we_i = '1')then
			evt_data_vld <= '0';
		end if;
		if(fifo_en = '0')then
			evt_buf_do_vld <= '0';
		elsif(FIFO_data_wa_q /= evt_buf_ra)then
			evt_buf_do_vld <= '1';
		elsif(evt_data_vld = '0' or evt_data_we_i = '1')then
			evt_buf_do_vld <= '0';
		end if;
		if(fifo_en = '0')then
			evt_buf_ra <= (others => '0');
		elsif(FIFO_data_wa_q /= evt_buf_ra and evt_buf_re = '1')then
			if(evt_buf_ra = x"f7f")then
				evt_buf_ra <= (others => '0');
			else
				evt_buf_ra <= evt_buf_ra + 1;
			end if;
		end if;
		trailer_dl <= trailer_dl(1 downto 0) & trailer_we;
		if(fifo_en = '0')then
			evt_cnt <= (others => '0');
		elsif(trailer_we = '1' and evt_data_re = '0')then
			evt_cnt <= evt_cnt + 1;
		elsif(trailer_we = '0' and evt_data_re = '1')then
			evt_cnt <= evt_cnt - 1;
		end if;
		if(fifo_en = '0')then
			evt_data_rdy <= '0';
		else
			evt_data_rdy <= or_reduce(evt_cnt) or or_reduce(evt_buf_wc(11 downto 8));
		end if;
		if(fifo_en = '0')then
			evt_buf_wc <= (others => '0');
		elsif(evt_data_we_i = '1' and FIFO_re = '0')then
			evt_buf_wc <= evt_buf_wc - 1;
		elsif(evt_data_we_i = '0' and FIFO_re = '1')then
			evt_buf_wc <= evt_buf_wc + 1;
		end if;
	end if;
end process;
g_evt_buf: for i in 0 to 7 generate
	i_evt_buf : BRAM_TDP_MACRO
   generic map (
      BRAM_SIZE => "36Kb", -- Target BRAM, "18Kb" or "36Kb" 
      DEVICE => "7SERIES", -- Target Device: "VIRTEX5", "VIRTEX6", "7SERIES", "SPARTAN6" 
      DOA_REG => 0, -- Optional port A output register (0 or 1)
      DOB_REG => 1, -- Optional port B output register (0 or 1)
      INIT_A => X"000000000", -- Initial values on A output port
      INIT_B => X"000000000", -- Initial values on B output port
      INIT_FILE => "NONE",
      READ_WIDTH_A => 9,   -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      READ_WIDTH_B => 9,   -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      SIM_COLLISION_CHECK => "NONE", -- Collision check enable "ALL", "WARNING_ONLY", 
                                    -- "GENERATE_X_ONLY" or "NONE" 
      SRVAL_A => X"000000000",   -- Set/Reset value for A port output
      SRVAL_B => X"000000000",   -- Set/Reset value for B port output
      WRITE_MODE_A => "WRITE_FIRST", -- "WRITE_FIRST", "READ_FIRST" or "NO_CHANGE" 
      WRITE_MODE_B => "WRITE_FIRST", -- "WRITE_FIRST", "READ_FIRST" or "NO_CHANGE" 
      WRITE_WIDTH_A => 9, -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      WRITE_WIDTH_B => 9) -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
   port map (
      DOA => evt_buf_doA(i*9+8 downto i*9),       -- Output port-A data, width defined by READ_WIDTH_A parameter
      DOB => evt_buf_dout(i*9+8 downto i*9),       -- Output port-B data, width defined by READ_WIDTH_B parameter
      ADDRA => evt_buf_wa,   -- Input port-A address, width defined by Port A depth
      ADDRB => evt_buf_ra,   -- Input port-B address, width defined by Port B depth
      CLKA => clk,     -- 1-bit input port-A clock
      CLKB => clk,     -- 1-bit input port-B clock
      DIA => evt_buf_din(i*9+8 downto i*9),       -- Input port-A data, width defined by WRITE_WIDTH_A parameter
      DIB => (others => '0'),       -- Input port-B data, width defined by WRITE_WIDTH_B parameter
      ENA => '1',       -- 1-bit input port-A enable
      ENB => evt_buf_re,       -- 1-bit input port-B enable
      REGCEA => '1', -- 1-bit input port-A output register enable
      REGCEB => evt_buf_regce, -- 1-bit input port-B output register enable
      RSTA => '0',     -- 1-bit input port-A reset
      RSTB => '0',     -- 1-bit input port-B reset
      WEA => evt_buf_we,       -- Input port-A write enable, width defined by Port A depth
      WEB => "0"        -- Input port-B write enable, width defined by Port B depth
   );
end generate;
evt_buf_regce <= not evt_data_vld or evt_data_we_i;
evt_buf_re <= not evt_buf_do_vld or not evt_data_vld or evt_data_we_i;
-- event word count and trailer
process(clk)
begin
	if(clk'event and clk = '1')then
		rd_last_header_q <= rd_last_header;
		if(fifo_en = '1' and ((last_channel = '1' and or_reduce(wc(9 downto 1)) = '0' and AMC_DATA_re_i = '1') or (rd_last_header_q = '1' and NoAMCenabled = '1')))then
			trailer_we <= '1';
		else
			trailer_we <= '0';
		end if;
		if(fifo_en = '0' or trailer_we = '1')then
			trailer(45 downto 32) <= "00000000000111";				
		elsif(AMC_DATA_re_i = '1')then
			trailer(45 downto 32) <= trailer(45 downto 32) + 1;				
		end if;
	end if;
end process;
trailer(63 downto 60) <= x"a";
trailer(59 downto 46) <= (others => '0');
trailer(31 downto 16) <= x"0000";
trailer(15 downto 8) <= Source_ID;
trailer(7 downto 0) <= x"00";
process(clk)
begin
	if(clk'event and clk = '1')then
		if(fifo_en = '0' or trailer_we = '1')then
			idle <= '1';
		elsif(AMC_header_re = '1')then
			idle <= '0';
		end if;
		if(fifo_en = '0' or (header_ra(2 downto 0) = "101" and AMC_header_we = '0'))then
			AMC_header_re <= '0';
		elsif(idle = '1' and AMC_header_avl = '1' and (wc_fifo_empty = '0' or NoAMCenabled = '1'))then
			AMC_header_re <= '1';
		end if;
		if(fifo_en = '0')then
			header_ra <= (others => '0');
		elsif(AMC_header_we = '0')then
			if(header_ra(2 downto 0) = "101")then
				header_ra(2 downto 0) <= "000";
				header_ra(6 downto 3) <= header_ra(6 downto 3) + 1;
			elsif(AMC_header_re = '1')then
				header_ra(2 downto 0) <= header_ra(2 downto 0) + 1;
			end if;
		end if;
		if(header_ra(2 downto 0) = "101" and AMC_header_we = '0')then
			rd_last_header <= '1';
		else
			rd_last_header <= '0';
		end if;
		if(fifo_en = '0' or (read_AMC = '1' and fifo_full(0) = '0'))then
			read_AMC <= '0';
		elsif((last_channel = '0' and or_reduce(wc(9 downto 1)) = '0' and AMC_DATA_re_i = '1') or (rd_last_header = '1' and  NoAMCenabled = '0'))then
			read_AMC <= '1';
		end if;
		if(fifo_en = '0' or (or_reduce(wc(9 downto 1)) = '0' and AMC_DATA_re_i = '1'))then
			AMC_DATA_re_i <= '0';
			AMC_DATA_re <= (others => '0');
		elsif(read_AMC = '1' and fifo_full(0) = '0')then
			AMC_DATA_re_i <= '1';
			AMC_DATA_re <= (others => '0');
			AMC_DATA_re(conv_integer(wc_fifo_do(13 downto 10))) <= '1';
		end if;
		if(AMC_header_re = '1')then
			last_channel <= '0';
		elsif(read_AMC = '1' and fifo_full(0) = '0')then
			last_channel <= wc_fifo_do(14);
		end if;
		if(read_AMC = '1' and fifo_full(0) = '0')then
			channel <= wc_fifo_do(13 downto 10);
			wc <= wc_fifo_do(9 downto 0);
		elsif(AMC_DATA_re_i = '1')then
			wc <= wc - 1;
		end if;
	end if;
end process;
end Behavioral;

